{
===============================================================================
  Copyright (©) 2002. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2002
  Versión actual: 1.0.1
  Fecha versión actual: 28-05-2004
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    28/05/2004    Se han adaptado los frames para que se autoconfiguren
===============================================================================
}

unit RdxFrameListadoBeneficios;

{$I ..\COMPILE.INC}

interface

uses
  Windows, Classes,
  RdxFrame, RdxDBFrame, IBCustomDataSet, DB, Entidades;

type
  TRdxFrameListadoBeneficios = class(TRdxDBFrame)
  private
    FCodigoContrato : Variant;
    FTablaBeneficios : TIBDataSet;
    FTablaFacturasProveedor : TIBDataSet;
    FTablaFacturasCliente : TIBDataSet;
    FTablaObrasGastos : TIBDataSet;

  protected
    procedure SetTablaBeneficios(const Value: TIBDataSet);
    procedure SetTablaFacturasProveedor (Value : TIBDataSet);
    procedure SetTablaFacturasCliente (Value : TIBDataSet);
    procedure SetTablaObrasGastos (Value : TIBDataSet);
    procedure SetCodigoContrato (Value : Variant);
    procedure RecargarDatosDetalle; virtual; abstract;
    function CambiarEntidad(EntidadAnterior, Entidad : TRdxEntidad): Boolean; override;
  public
    property TablaBeneficios: TIBDataSet read FTablaBeneficios write SetTablaBeneficios;
    property TablaFacturasCliente: TIBDataSet read FTablaFacturasCliente write SetTablaFacturasCliente;
    property TablaFacturasProveedor: TIBDataSet read FTablaFacturasProveedor write SetTablaFacturasProveedor;
    property TablaObrasGastos: TIBDataSet read FTablaObrasGastos write SetTablaObrasGastos;
    property CodigoContrato : Variant read FCodigoContrato write SetCodigoContrato;

    constructor Create (AOwner : TComponent); override;
  published
  end;

implementation

{$R *.DFM}

uses
  StrFunc, Mensajes, Literales, Configuracion
  {$IFDEF RDX_D6}, Variants{$ENDIF};

{ TRdxFrameListadoBeneficiosCliente }

constructor TRdxFrameListadoBeneficios.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FTablaFacturasCliente := NIL;
  FTablaFacturasProveedor := NIL;
  FTablaObrasGastos := NIL;
end;

procedure TRdxFrameListadoBeneficios.SetTablaObrasGastos(Value: TIBDataSet);
begin
  if (FTablaObrasGastos <> Value) then
  begin
    FTablaObrasGastos := Value;
  end;
end;

procedure TRdxFrameListadoBeneficios.SetTablaFacturasProveedor(Value: TIBDataSet);
begin
  if (FTablaFacturasProveedor <> Value) then
  begin
    FTablaFacturasProveedor := Value;
  end;
end;

procedure TRdxFrameListadoBeneficios.SetTablaFacturasCliente(Value: TIBDataSet);
begin
  if (FTablaFacturasCliente <> Value) then
  begin
    FTablaFacturasCliente := Value;
  end;
end;

procedure TRdxFrameListadoBeneficios.SetCodigoContrato(Value: Variant);
begin
  if (FCodigoContrato = Value) then
    exit;

  FCodigoContrato := Value;
  RecargarDatosDetalle;
end;

function TRdxFrameListadoBeneficios.CambiarEntidad(EntidadAnterior, Entidad: TRdxEntidad): Boolean;
begin
  inherited CambiarEntidad(EntidadAnterior, Entidad);
  ConfigurarFrame(Self, Self.Entidad);
end;

procedure TRdxFrameListadoBeneficios.SetTablaBeneficios(const Value: TIBDataSet);
begin
  if (FTablaBeneficios <> Value) then
  begin
    FTablaBeneficios := Value;
  end;
end;

end.
